OpenTTD: CYapfRoad2 Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

CYapfRoad2 Struct Reference
Inheritance diagram for CYapfRoad2:

## Additional Inherited Members
Public Types inherited from CYapfBaseT< Types >
typedef Types::Tpf | Tpf
| the pathfinder class (derived from THIS class)
typedef Types::TrackFollower | TrackFollower
typedef Types::NodeList | NodeList
| our node list
typedef Types::VehicleType | VehicleType
| the type of vehicle
typedef NodeList::Titem | Node
| this will be our node type
typedef Node::Key | Key
| key to hash tables
Public Types inherited from CYapfCostRoadT< Types >
typedef Types::Tpf | Tpf
| pathfinder (derived from THIS class)
typedef Types::TrackFollower | TrackFollower
| track follower helper
typedef Types::NodeList::Titem | Node
| this will be our node type
typedef Node::Key | Key
| key to hash tables
Public Types inherited from CYapfSegmentCostCacheNoneT< Types >
typedef Types::Tpf | Tpf
| the pathfinder class (derived from THIS class)
typedef Types::NodeList::Titem | Node
| this will be our node type
Public Types inherited from CYapfOriginTileT< Types >
typedef Types::Tpf | Tpf
| the pathfinder class (derived from THIS class)
typedef Types::NodeList::Titem | Node
| this will be our node type
typedef Node::Key | Key
| key to hash tables
Public Types inherited from CYapfDestinationAnyDepotRoadT< Types >
typedef Types::Tpf | Tpf
| the pathfinder class (derived from THIS class)
typedef Types::TrackFollower | TrackFollower
typedef Types::NodeList::Titem | Node
| this will be our node type
typedef Node::Key | Key
| key to hash tables
Public Types inherited from CYapfFollowRoadT< Types >
typedef Types::Tpf | Tpf
| the pathfinder class (derived from THIS class)
typedef Types::TrackFollower | TrackFollower
typedef Types::NodeList::Titem | Node
| this will be our node type
typedef Node::Key | Key
| key to hash tables
Public Member Functions inherited from CYapfBaseT< Types >
| CYapfBaseT ()
| default constructor
| ~CYapfBaseT ()
| default destructor
const YAPFSettings & | PfGetSettings () const
| return current settings (can be custom - company based - but later)
bool | FindPath (const VehicleType *v)
| Main pathfinder routine:
Node * | GetBestNode ()
| If path was found return the best node that has reached the destination.
Node & | CreateNewNode ()
| Calls NodeList::CreateNewNode() - allocates new node that can be filled and used as argument for AddStartupNode() or AddNewNode()
void | AddStartupNode (Node &n)
| Add new node (created by CreateNewNode and filled with data) into open list.
void | AddMultipleNodes (Node *parent, const TrackFollower &tf)
| add multiple nodes - direct children of the given node
void | PruneIntermediateNodeBranch ()
| In some cases an intermediate node branch should be pruned.
void | AddNewNode (Node &n, const TrackFollower &tf)
| AddNewNode() - called by Tderived::PfFollowNode() for each child node.
const VehicleType * | GetVehicle () const
void | DumpBase (DumpTarget &dmp) const
Public Member Functions inherited from CYapfCostRoadT< Types >
bool | PfCalcCost (Node &n, const TrackFollower *tf)
| Called by YAPF to calculate the cost from the origin to the given node.
Public Member Functions inherited from CYapfSegmentCostCacheNoneT< Types >
bool | PfNodeCacheFetch (Node &n)
| Called by YAPF to attach cached or local segment cost data to the given node.
void | PfNodeCacheFlush (Node &n)
| Called by YAPF to flush the cached segment cost data back into cache storage.
Public Member Functions inherited from CYapfOriginTileT< Types >
void | SetOrigin (TileIndex tile, TrackdirBits trackdirs)
| Set origin tile / trackdir mask.
void | PfSetStartupNodes ()
| Called when YAPF needs to place origin nodes into open list.
Public Member Functions inherited from CYapfDestinationAnyDepotRoadT< Types >
Tpf & | Yapf ()
| to access inherited path finder
bool | PfDetectDestination (Node &n)
| Called by YAPF to detect if node ends in the desired destination.
bool | PfDetectDestinationTile (TileIndex tile, Trackdir trackdir)
bool | PfCalcEstimate (Node &n)
| Called by YAPF to calculate cost estimate.
Public Member Functions inherited from CYapfFollowRoadT< Types >
void | PfFollowNode (Node &old_node)
| Called by YAPF to move from the given node to the next tile.
char | TransportTypeChar () const
| return debug report character to identify the transportation type
Trackdir | ChooseRoadTrack (const RoadVehicle *v, TileIndex tile, DiagDirection enterdir, bool &path_found)
uint | DistanceToTile (const RoadVehicle *v, TileIndex dst_tile)
bool | SetOriginFromVehiclePos (const RoadVehicle *v)
| Return true if the valid origin (tile/trackdir) was set from the current vehicle position.
FindDepotData | FindNearestDepot (const RoadVehicle *v, TileIndex tile, Trackdir td, int max_distance)
| Find the best depot for a road vehicle.
Static Public Member Functions inherited from CYapfFollowRoadT< Types >
static Trackdir | stChooseRoadTrack (const RoadVehicle *v, TileIndex tile, DiagDirection enterdir, bool &path_found)
static uint | stDistanceToTile (const RoadVehicle *v, TileIndex tile)
static FindDepotData | stFindNearestDepot (const RoadVehicle *v, TileIndex tile, Trackdir td, int max_distance)
Data Fields inherited from CYapfBaseT< Types >
NodeList | m_nodes
| node list multi-container
CPerformanceTimer | m_perf_cost
| stats - total CPU time of this run
CPerformanceTimer | m_perf_slope_cost
| stats - slope calculation CPU time
CPerformanceTimer | m_perf_ts_cost
| stats - GetTrackStatus() CPU time
CPerformanceTimer | m_perf_other_cost
| stats - other CPU time
int | m_num_steps
| this is there for debugging purposes (hope it doesn't hurt)
Protected Member Functions inherited from CYapfBaseT< Types >
Tpf & | Yapf ()
| to access inherited path finder
Protected Member Functions inherited from CYapfCostRoadT< Types >
Tpf & | Yapf ()
| to access inherited path finder
int | SlopeCost (TileIndex tile, TileIndex next_tile, Trackdir trackdir)
int | OneTileCost (TileIndex tile, Trackdir trackdir)
| return one tile cost
Protected Member Functions inherited from CYapfOriginTileT< Types >
Tpf & | Yapf ()
| to access inherited path finder
Protected Member Functions inherited from CYapfFollowRoadT< Types >
Tpf & | Yapf ()
| to access inherited path finder
Protected Attributes inherited from CYapfBaseT< Types >
Node * | m_pBestDestNode
| pointer to the destination node found at last round
Node * | m_pBestIntermediateNode
| here should be node closest to the destination if path not found
const YAPFSettings * | m_settings
| current settings (_settings_game.yapf)
int | m_max_search_nodes
| maximum number of nodes we are allowed to visit before we give up
const VehicleType * | m_veh
| vehicle that we are trying to drive
int | m_stats_cost_calcs
| stats - how many node's costs were calculated
int | m_stats_cache_hits
| stats - how many node's costs were reused from cache
Protected Attributes inherited from CYapfOriginTileT< Types >
TileIndex | m_orgTile
| origin tile
TrackdirBits | m_orgTrackdirs
| origin trackdir mask

## Detailed Description

Definition at line 482 of file yapf_road.cpp.

The documentation for this struct was generated from the following file:

- src/pathfinder/yapf/yapf_road.cpp